** Clean CPI Data to be Used to Deflate Nominal Variables

set more off, perm
clear all
scalar drop _all
cls

global drctory = "/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build"

capture log close
log using "${drctory}/temp/clean_bei.log", text replace

***************************************************************
*                      Load                                   *
***************************************************************

insheet using "${drctory}/input/bei.csv", clear

***************************************************************
*                      Normalize                              *
***************************************************************

cap drop temp
gen temp = bei1991 if state==06
egen bei1991_CA = max(temp)
egen bei1991_max = max(bei1991)
gen bei1991_scaled = (bei1991-bei1991_CA)/(bei1991_max-bei1991_CA)
drop temp bei1991_CA bei1991_max

cap drop temp
gen temp = bei2009 if state==06
egen bei2009_CA = max(temp)
egen bei2009_max = max(bei2009)
gen bei2009_scaled = (bei2009-bei2009_CA)/(bei2009_max-bei2009_CA)
drop temp bei2009_CA bei2009_max

***************************************************************
*                      Save                                   *
***************************************************************

drop state_code

save "${drctory}/output/bei.dta", replace

log close  
