
set more off, perm
clear all
scalar drop _all
cls

global drctory = "/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build"

capture log close
log using "${drctory}/temp/0_clean_link.log", text replace

***************************************************************
*                      Load                                   *
***************************************************************

insheet using "${drctory}/input/link/company_id_link.csv"

***************************************************************
*               Save  gvkey-cik link                          *
***************************************************************

preserve 
keep gvkey cik tic cusip
gsort cik
quietly by cik: gen dup = cond(_N==1,0,_n)
drop if dup>1
drop dup
drop tic
save "${drctory}/output/link/gvkey_cik_link.dta", replace
restore

***************************************************************
*               Save  gvkey-tik link                          *
***************************************************************

preserve 
keep gvkey cik tic cusip
gsort tic
quietly by tic: gen dup = cond(_N==1,0,_n)
drop if dup>1
drop dup
keep tic gvkey
keep if !mi(tic)
save "${drctory}/output/link/gvkey_tic_link.dta", replace
restore

***************************************************************
*               Save  gvkey-permo link                          *
***************************************************************

preserve 
duplicates drop
rename lpermno permno
keep if !mi(permno) == 1
keep gvkey permno linkdt linkenddt
duplicates drop 
* Keep Unique Values
sort gvkey
quietly by gvkey: gen dup = cond(_N==1,0,_n)
drop if dup>1
drop dup
sort permno
quietly by permno: gen dup = cond(_N==1,0,_n)
drop if dup>1
drop dup
keep gvkey permno 
save "${drctory}/output/link/gvkey_permno_link.dta", replace
restore 

***************************************************************
*                         More Links                          *
***************************************************************

clear all
insheet using "${drctory}/input/link/IBES_CRSP_link.csv"

keep ticker permno ncusip 
merge m:1 permno using "${drctory}/output/link/gvkey_permno_link.dta", keep(match master)
drop _merge
keep ticker gvkey
rename ticker tic
gsort tic
quietly by tic: gen dup = cond(_N==1,0,_n)
drop if dup>1
drop dup

save "${drctory}/output/link/more_links.dta", replace

log close
