

sort gvkey year 
quietly by gvkey: gen ppegt_lag = ppegt[_n-1]
quietly by gvkey: gen ppent_lag = ppent[_n-1]

* lagged tobinq for investment regression
gen tobinq = (at+prcc_f*csho-ceq-txdb)/ppegt
gen mb = (at+prcc_f*csho-ceq-txdb)/at
quietly by gvkey: gen tobinq_lag = tobinq[_n-1]
quietly by gvkey: gen mb_lag = mb[_n-1]
quietly by gvkey: gen q_tot_lag = q_tot[_n-1]

gen inv = capx/ppegt_lag
gen inv_alt = (capx-sppe)/ppent_lag
gen cash = (ib+dp)/ppegt_lag

***************************************************************
*                        Investments 
***************************************************************

replace dlc = 0 if dlc == .
replace dltt = 0 if dltt == .
replace ppent = 0 if ppent == .
replace capx = 0 if capx == .
replace xrd = 0 if xrd == .
replace xsga = 0 if xsga == .

replace xrd = 0 if mi(xrd)
replace k_int = 0 if mi(k_int)

gen k_tot = ppegt+k_int

sort gvkey year 
quietly by gvkey: gen k_tot_lag = k_tot[_n-1]
gen inv_int = (xrd+.3*xsga)/k_tot_lag
gen inv_phy = capx/k_tot_lag
gen inv_tot = (inv_int+inv_phy)

gen xrd_rate = xrd/at
gen xsga_rate = xsga/at

gen xrd_rate2 = xrd/revt
gen xsga_rate2 = xsga/revt

gen lever_rate = (dlc+dltt)/at
gen ppent_rate = ppent/at

***************************************************************
*                      Growth Firms
***************************************************************

sort gvkey year
bysort gvkey: gen g_revt = (revt[_n]-revt[_n-1])/(revt[_n]+revt[_n-1])/2
bysort gvkey: gen g_at = (at[_n]-at[_n-1])/(at[_n]+at[_n-1])/2
bysort gvkey: gen g_emp = (emp[_n]-emp[_n-1])/(emp[_n]+emp[_n-1])/2

bysort gvkey: gen g_revt1 = (revt[_n]-revt[_n-1])/revt[_n-1]
bysort gvkey: gen g_at1 = (at[_n]-at[_n-1])/at[_n-1]
bysort gvkey: gen g_emp1 = (emp[_n]-emp[_n-1])/emp[_n-1]


