
***************************************************************
*                      Industry Definition
***************************************************************

gen sic2 = int(sic/100)
gen sic3 = int(sic/10)
gen naics4 = int(naics/100)

***************************************************************
*                      Concentration Measure
***************************************************************

gen N_temp = 1
gen at_temp = at 
replace at_temp = 0 if at<0
gen emp_temp = emp 
replace emp_temp = 0 if emp<0
gen revt_temp = revt 
replace revt_temp = 0 if revt<0
gen ca_temp = 0
replace ca_temp = 1 if state!=06

quietly bysort state sic2 year: gen temp_sic2 = (_n==1)
quietly bysort state sic2 year: gen state_sic2_N = sum(N_temp)
quietly bysort state sic2 year: gen state_sic2_at = sum(at_temp)
quietly bysort state sic2 year: gen state_sic2_emp = sum(emp_temp)
quietly bysort state sic2 year: gen state_sic2_revt = sum(revt_temp)

quietly bysort state sic3 year: gen temp_sic3 = (_n==1)
quietly bysort state sic3 year: gen state_sic3_N = sum(N_temp)
quietly bysort state sic3 year: gen state_sic3_at = sum(at_temp)
quietly bysort state sic3 year: gen state_sic3_emp = sum(emp_temp)
quietly bysort state sic3 year: gen state_sic3_revt = sum(revt_temp)

quietly bysort state sic year: gen temp_sic = (_n==1)
quietly bysort state sic year: gen state_sic_N = sum(N_temp)
quietly bysort state sic year: gen state_sic_at = sum(at_temp)
quietly bysort state sic year: gen state_sic_emp = sum(emp_temp)
quietly bysort state sic year: gen state_sic_revt = sum(revt_temp)

quietly bysort state naics4 year: gen temp_naics4 = (_n==1)
quietly bysort state naics4 year: gen state_naics4_N = sum(N_temp)
quietly bysort state naics4 year: gen state_naics4_at = sum(at_temp)
quietly bysort state naics4 year: gen state_naics4_emp = sum(emp_temp)
quietly bysort state naics4 year: gen state_naics4_revt = sum(revt_temp)

quietly bysort sic2 year: egen frac_nonca_sic2 = mean(ca_temp)
quietly bysort sic3 year: egen frac_nonca_sic3 = mean(ca_temp)
quietly bysort sic year: egen frac_nonca_sic = mean(ca_temp)
quietly bysort naics4 year: egen frac_nonca_naics4 = mean(ca_temp)

sum frac_nonca*

***************************************************************
*      Define bei by industry (state composition weighted )   *
***************************************************************
			 
quietly bysort sic2 year: asgen bei_sic2_N = bei2009_scaled, w(N_temp)
quietly bysort sic2 year: asgen bei_sic2_at = bei2009_scaled, w(at_temp)
quietly bysort sic2 year: asgen bei_sic2_emp = bei2009_scaled, w(emp_temp)
quietly bysort sic2 year: asgen bei_sic2_revt = bei2009_scaled, w(revt_temp)

quietly bysort sic3 year: asgen bei_sic3_N = bei2009_scaled, w(N_temp)
quietly bysort sic3 year: asgen bei_sic3_at = bei2009_scaled, w(at_temp)
quietly bysort sic3 year: asgen bei_sic3_emp = bei2009_scaled, w(emp_temp)
quietly bysort sic3 year: asgen bei_sic3_revt = bei2009_scaled, w(revt_temp)

quietly bysort sic year: asgen bei_sic_N = bei2009_scaled, w(N_temp)
quietly bysort sic year: asgen bei_sic_at = bei2009_scaled, w(at_temp)
quietly bysort sic year: asgen bei_sic_emp = bei2009_scaled, w(emp_temp)
quietly bysort sic year: asgen bei_sic_revt = bei2009_scaled, w(revt_temp)

quietly bysort naics4 year: asgen bei_naics4_N = bei2009_scaled, w(N_temp)
quietly bysort naics4 year: asgen bei_naics4_at = bei2009_scaled, w(at_temp)
quietly bysort naics4 year: asgen bei_naics4_emp = bei2009_scaled, w(emp_temp)
quietly bysort naics4 year: asgen bei_naics4_revt = bei2009_scaled, w(revt_temp)

sum bei2009_scaled ///
	bei_sic2_N bei_sic2_at bei_sic2_emp bei_sic2_revt ///
	bei_sic3_N bei_sic3_at bei_sic3_emp bei_sic3_revt ///
	bei_naics4_N bei_naics4_at bei_naics4_emp bei_naics4_revt

drop N_temp at_temp emp_temp revt_temp ca_temp temp*

