
set more off, perm
clear all
scalar drop _all
cls

global drctory = "/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build"

capture log close
log using "${drctory}/temp/1_clean_individual_profile.log", text replace


***************************************************************
*                      Load                                   *
***************************************************************

insheet using "${drctory}/input/boardex/individual_profile.csv"

keep directorid dob dod nationality
order directorid dob dod nationality
sort directorid

***************************************************************
*             Merge with Names Matched to Execucomp
***************************************************************


* clean up birth year, death year
replace dob = "." if dob == "n.a."
replace dob = substr(dob,strlen(dob)-4,5) if strlen(dob)>4
replace dod = "." if dod == "n.a."
replace dod = substr(dod,strlen(dod)-4,5) if strlen(dod)>4
destring dob dod, replace

***************************************************************
*                      Save                                   *
***************************************************************

save "${drctory}/output/boardex/individual_profile.dta", replace

log close
