# coding: utf-8
import os
import re
import numpy as np
import pandas as pd
from fuzzywuzzy import fuzz
from fuzzywuzzy import process
import sys
reload(sys)
sys.setdefaultencoding('utf-8')
np.set_printoptions(threshold=np.inf)

def get_min(list):
	try:
		list_temp = [map(int, x) for x in list if re.match(r"[0-9]+", x)]
		result = max()
	except:
		result = '.'
	return result

"""
BASIC FILES/PATHS
"""

base_dir = os.path.join("/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build")
input_dir = os.path.join(base_dir, "output/boardex")
out_dir = os.path.join(base_dir, "output/boardex")

"""
READ MASTER FILE
"""

master_file = os.path.join(input_dir, "company_profile1.csv")
output_p = os.path.join(out_dir, "matched_bdex_company.p")
output_csv = os.path.join(out_dir, "matched_bdex_company.csv")

if os.path.exists(output_p):
	os.remove(output_p)
if os.path.exists(output_csv):
	os.remove(output_csv)

master_df = pd.read_csv(master_file, quotechar = '"', skipinitialspace = True, sep = ',')
print " *** Now printing column values for master file *** "
print list(master_df.columns.values)
print master_df.dtypes

num_match = 2
df = pd.DataFrame()

unmatched_file = "company_profile2.csv"
print(unmatched_file)
using_file = os.path.join(out_dir, unmatched_file)

using_df = pd.read_csv(using_file, quotechar = '"', skipinitialspace = True, sep = ',', encoding='latin-1')
print " *** Now printing column values for using file *** "
print list(using_df.columns.values)
print using_df.dtypes

"""
MODIFY STRINGS
"""

## remove some redundant components in boardname
using_df['boardname_short'] = using_df['boardname'].str.replace(r'\(.*', '',case=False)
master_df['boardname_short'] = master_df['boardname'].str.replace(r'\(.*', '',case=False)
using_df['initial'] = using_df['boardname'].str.extract(r"(.{1})")
master_df['initial'] = master_df['boardname'].str.extract(r"(.{1})")


"""
MATCH
"""

set_header = 1

for index, row in using_df.iterrows():
	print(index, row.boardname,  row.boardname_short, row.initial, row.boardid)

	# important!
	# the increase in speed is at least 10-fold, 20-fold, by matching to selected firms with identical initial
	# the only good matches are score==100, always have the same initial anyway
	master_temp = master_df[master_df.initial==row.initial]

	df1 = pd.DataFrame(row)
	df1 = df1.T

	try:
		match = process.extract(row.boardname_short.decode('utf-8'), master_temp.boardname_short, limit=num_match)
		print match

		# -- generate column names
		num_column = num_match
		lab = ""
		i = 1
		while i <= num_column:
			lab = lab + " " + "match" + str(i)
			i += 1

		match_df = pd.DataFrame([match], columns=lab.split())
		df2 = {}
		if len(match)==2:
			for x in range(1, num_column + 1):
				df2["match{0}".format(x)] = [y[0] for y in match_df['match' + str(x)]]
				df2["score{0}".format(x)] = [y[1] for y in match_df['match' + str(x)]]
		else:
			df2["match1"] = [y[0] for y in match_df['match1']]
			df2["score1"] = [y[1] for y in match_df['match1']]
			df2["match2"] = "NA"
			df2["score2"] = 0
		df2 = pd.DataFrame(df2)

		df3 = master_temp[master_temp.boardname_short == df2.match1[0]]

		df1.reset_index(drop=True, inplace=True)
		df2.reset_index(drop=True, inplace=True)
		df3.reset_index(drop=True, inplace=True)
		df_new = pd.concat([df1, df2, df3], axis=1)

		try:
			with open(output_csv, 'a') as f:
				if set_header == 1:
					df_new.to_csv(f, sep='|', line_terminator='\n', header=True, index=False)
					set_header = 0
				else:
					df_new.to_csv(f, sep='|', line_terminator='\n', header=False, index=False)
		except Exception as e:
			print(e)

		df = df.append(df_new, ignore_index=True)
	except Exception as e:
		print(e)

df.to_pickle(output_p)
