# coding: utf-8
import os
import re
import numpy as np
import pandas as pd
from fuzzywuzzy import fuzz
from fuzzywuzzy import process
import sys
reload(sys)
sys.setdefaultencoding('utf-8')
np.set_printoptions(threshold=np.inf)

def get_min(list):
	try:
		list_temp = [map(int, x) for x in list if re.match(r"[0-9]+", x)]
		result = max()
	except:
		result = '.'
	return result

"""
BASIC FILES/PATHS
"""

base_dir = os.path.join("/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build")
input_dir = os.path.join(base_dir, "output/execucomp")
out_dir = os.path.join(base_dir, "output/boardex")

if not os.path.exists(out_dir):
	os.makedirs(out_dir)

"""
READ MASTER FILE
"""

master_file = os.path.join(input_dir, "name_list.csv")
output_p = os.path.join(out_dir, "matched_name.p")
output_csv = os.path.join(out_dir, "matched_name.csv")

if os.path.exists(output_p):
	os.remove(output_p)
if os.path.exists(output_csv):
	os.remove(output_csv)

master_df = pd.read_csv(master_file, quotechar = '"', skipinitialspace = True, sep = ',', dtype={'gvkey':object})
print " *** Now printing column values for master file *** "
print list(master_df.columns.values)
print master_df.dtypes

master_df['exec_fullname'] = master_df['exec_fullname'].str.replace(r',.*', '')

num_match = 3
df = pd.DataFrame()

director_file = 'director_list.csv'
print(director_file)
using_file = os.path.join(out_dir, director_file)

using_df = pd.read_csv(using_file, quotechar = '"', skipinitialspace = True, sep = ',', dtype={'gvkey':object}, encoding='latin-1')
print " *** Now printing column values for using file *** "
print list(using_df.columns.values)
print using_df.dtypes

using_df.to_csv(os.path.join(out_dir, "using_check.csv"))

"""
MODIFY STRINGS
"""

using_df['directorname'] = using_df['directorname'].str.replace(r',.*', '')

"""
MATCH
"""

set_header = 1

for index, row in using_df.iterrows():
	print(index, row.gvkey, row.directorname)

	df1 = pd.DataFrame(row)
	df1 = df1.T

	master_temp = master_df[master_df.gvkey == row.gvkey]

	try:
	# quite important to add fuzz.token_set_ratio
		match = process.extract(row.directorname.decode('utf-8'), master_temp.exec_fullname, scorer=fuzz.token_set_ratio, limit=num_match)
		print match

		# -- generate column names
		num_column = min(num_match,len(match))
		lab = ""
		i = 1
		while i <= num_column:
			lab = lab + " " + "match" + str(i)
			i += 1

		match_df = pd.DataFrame([match], columns=lab.split())
		df2 = {}
		for x in range(1, num_column + 1):
			df2["match{0}".format(x)] = [y[0] for y in match_df['match' + str(x)]]
			df2["score{0}".format(x)] = [y[1] for y in match_df['match' + str(x)]]
		df2 = pd.DataFrame(df2)
		df2['flag'] = 0
		if num_column >= 2:
			df2['flag'] = (df2['score1']<=86) & (df2['score1']-df2['score2']<=10)

		df3 = master_temp[master_temp.exec_fullname == df2.match1[0]]
		df3 = df3.drop(['coname'], axis=1)

		df1.reset_index(drop=True, inplace=True)
		df2.reset_index(drop=True, inplace=True)
		df3.reset_index(drop=True, inplace=True)
		df_new = pd.concat([df1, df2, df3], axis=1)

		try:
			with open(output_csv, 'a') as f:
				if set_header == 1:
					df_new.to_csv(f, sep='|', line_terminator='\n', header=True, index=False)
					set_header = 0
				else:
					df_new.to_csv(f, sep='|', line_terminator='\n', header=False, index=False)
		except Exception as e:
			print(e)

		df = df.append(df_new, ignore_index=True)
	except Exception as e:
		print(e)

df.to_pickle(output_p)
