
set more off, perm
clear all
scalar drop _all
cls

global drctory = "/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build"

capture log close
log using "${drctory}/temp/3.3_filter_matched_name.log", text replace

***************************************************************
*                      Load                                   *
***************************************************************

import delimited "${drctory}/output/boardex/matched_name_modify.csv", delimiter("|") varnames(1) encoding(ISO-8859-1) clear

count
keep directorname directorid gvkey match1 score1 execid
duplicates drop

***************************************************************
*                      Filter
***************************************************************

* keep high score
keep if score1>=86

* keep unique execid-directorid match
bysort execid: gen num_director = _N
bysort directorid: gen num_exec = _N
bysort execid directorid: gen num = _N

cap drop temp
gen temp=0
replace temp=1 if num==num_director 
replace temp=1 if num_director-num==1 & num_director>2
keep if temp==1
drop temp

cap drop temp
gen temp=0
replace temp=1 if num==num_exec
replace temp=1 if num_exec-num==1 & num_exec>2
keep if temp==1
drop temp

***************************************************************
*                      Filter
***************************************************************

keep directorid execid
duplicates drop

save "${drctory}/output/boardex/matched_name_filter.dta", replace

log close
