set more off, perm
clear all
scalar drop _all
cls

global drctory = "/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build"

capture log close
log using "${drctory}/temp/clean_boardex.log", text replace

***************************************************************
*                      Load                                   *
***************************************************************

insheet using "${drctory}/input/boardex/individual_employment.csv"

***************************************************************
*                      Merge                                  *
***************************************************************

* keep if hocountryname == "United States"

merge m:1 companyid using "${drctory}/output/boardex/company_profile.dta"
tab _merge orgtype

** keep directorid with any company matched
**  this allows to keep private companies
bysort directorid : egen found = max(_merge)
keep if found == 3
drop _merge found

cap drop temp
bysort companyid: egen temp = mode(companyid_matched), maxmode
replace companyid_matched = temp
drop temp

***************************************************************
*                      Save                                   *
***************************************************************

save "${drctory}/output/boardex/individual_employment.dta", replace

***************************************************************
* Save a list of directorname to merge with the ones in ExecuComp
***************************************************************

keep if orgtype == "Quoted"
keep if !mi(gvkey)

keep directorname directorid gvkey gvkey_type
duplicates drop
count

export delimited using "${drctory}/output/boardex/director_list.csv", replace

log close 








