set more off, perm
clear all
scalar drop _all
cls

global drctory = "/Users/liyan/Dropbox/Noncompete/replication_package/empirical/build"

capture log close
log using "${drctory}/temp/1.2_clean_improved_match_id.log", text replace

***************************************************************
*                      Load
***************************************************************

import delimited "${drctory}/output/execucomp/list_improved_companyid.csv", delimiter("|") varnames(1) encoding(ISO-8859-1) clear

tab score 
tab score_bracket
tab score_private

***************************************************************
*                      Filter
***************************************************************

gen temp_keep=0 
replace temp_keep=1 if !mi(score) & score>=93
replace temp_keep=2 if temp_keep==0 & !mi(score_bracket) & score_bracket>=91 
replace match=match_bracket if temp_keep==2
replace score=score_bracket if temp_keep==2
replace gvkey_matched=gvkey_matched_bracket if temp_keep==2
replace temp_keep=3 if !mi(score_private) & score_private>=93
keep if temp_keep>=1

keep execid companyid gvkey_matched companyid_match companyname match score match_private score_private temp_keep
order execid companyid gvkey_matched companyid_match companyname match score match_private score_private temp_keep

gen gvkey_final = gvkey_matched if temp==1 | temp==2

***************************************************************
*                      Fix Private Companies
***************************************************************

format companyname match match_private %12s

gen temp1=1 if temp_keep==3
bysort execid: egen temp_count = sum(temp1) if temp_keep==3
drop temp1
tab temp_count

sort execid companyid_matched temp_keep
bysort execid: gen temp1 = 1 if companyid_matched!=companyid_matched[_n-1] & temp_keep==3 & temp_keep[_n-1]==3
bysort execid: replace temp1 = 1 if temp_keep==3 & (temp_keep[_n-1]!=3 | _n==1)
bysort execid: egen unicount = sum(temp1) if temp_keep==3
drop temp1

gen companyid_final = companyid_matched if temp_count==1
replace companyid_final=companyid_matched if temp_count==2 & unicount==1
replace companyid_final=companyid_matched if temp_count>2 & unicount==1

** executive has 2 matches
cap drop check_mutual
gen check_mutual = 0 if temp_count==2
bysort execid: replace check_mutual = 1 if companyid==companyid_matched[_n+1] & companyid[_n+1]==companyid_matched & temp_count==2
bysort execid: replace check_mutual = 1 if companyid[_n-1]==companyid_matched & companyid ==companyid_matched[_n-1] & temp_count==2
replace companyid_final = companyid_matched if check_mutual==0 & temp_count==2
bysort execid: replace companyid_final = companyid_matched[1] if check_mutual==1 & temp_count==2
drop check_mutual

** executive has 3 matches
cap drop check_mutual
gen check_mutual = 0 if temp_count==3 & unicount==2
bysort execid: egen temp_mode = mode(companyid_matched), maxmode
replace check_mutual = 1 if (companyid_matched==temp_mode | companyid==temp_mode) & temp_count==3 & unicount==2
replace companyid_final=temp_mode if check_mutual==1 & temp_count==3 & unicount==2
replace companyid_final=companyid_matched if check_mutual==0 & temp_count==3 & unicount==2
drop check_mutual temp_mode

cap drop check_mutual
gen check_mutual = 0 if temp_count==3 & unicount==3
bysort execid: replace check_mutual = 1 if inlist(companyid,companyid_matched[2],companyid_matched[3]) & temp_count==3 & unicount==3
bysort execid: replace check_mutual = 1 if inlist(companyid,companyid_matched[1],companyid_matched[3]) & temp_count==3 & unicount==3
bysort execid: replace check_mutual = 1 if inlist(companyid,companyid_matched[1],companyid_matched[2]) & temp_count==3 & unicount==3
gen temp = . if temp_count==3 & unicount==3
replace temp = companyid_matched if check_mutual==1 & temp_count==3 & unicount==3
bysort execid: egen temp_mode = mode(temp), maxmode
replace companyid_final=temp_mode if check_mutual==1 & temp_count==3 & unicount==3
replace companyid_final=companyid_matched if check_mutual==0 & temp_count==3 & unicount==3
drop temp temp_mode check_mutual

** executive has 4 matches
cap drop check_mutual
gen check_mutual = 0 if temp_count==4 & unicount==2
bysort execid: egen temp_mode = mode(companyid_matched), maxmode
replace check_mutual = 1 if (companyid_matched==temp_mode | companyid==temp_mode) & temp_count==4 & unicount==2
replace companyid_final=temp_mode if temp_count==4 & unicount==2
drop check_mutual temp_mode

***************************************************************
*                      Save
***************************************************************


keep execid companyid gvkey_matched gvkey_final companyid_matched companyid_final companyname match score score_private
order execid companyid gvkey_matched gvkey_final companyid_matched companyid_final companyname match score score_private
duplicates drop
count

save "${drctory}/output/execucomp/list_improved_companyid_filter.dta", replace

log close 
 
