
***************************************************************
*                     GEN STATE LEVEL DATA FOR PLOT
***************************************************************

* save a state-level dataset
preserve
keep if !mi(nc)
keep if year>=1992 & year<=2015

** By state
quietly by co_per_rol, sort: keep if _n == 1
keep if !mi(nc)
quietly by state, sort: egen num_match = count(co_per_rol)
quietly by state, sort: egen num_nc = sum(nc)
quietly by state, sort: egen num_dur = count(dur_max)
quietly by state, sort: egen nc_mean = mean(nc)
quietly by state, sort: egen dur_min_mean = mean(dur_min) if dur_min>0
quietly by state, sort: egen dur_max_mean = mean(dur_max) if dur_max>0
egen nc_mean_all = mean(nc)
quietly by state, sort: gen id_keep = _n==1
keep if id_keep == 1
keep state num_match num_nc num_dur nc_mean dur_min_mean dur_max_mean ///
	 bei1991_scaled bei2009_scaled
drop if state == .

save "${drctory}/analysis/input/aggregate_data/nc_state.dta", replace
restore 

* save a time-series dataset
preserve
keep if year>=1992 & year<=2015
collapse (mean) nc, by(year)
save "${drctory}/analysis/input/aggregate_data/nc_year.dta", replace
restore 

* save a state-level time-series dataset
preserve
gen nc_p1 = nc if year>=1992 & year<=1995
gen nc_p2 = nc if year>=2012 & year<=2015 
quietly by state, sort: egen num_match = count(co_per_rol)
collapse (mean) nc_p1 nc_p2 num_match, by(state)
save "${drctory}/analysis/input/aggregate_data/nc_state_year.dta", replace
restore 
