
***************************************************************
*                      Firm Ratios
**************************************************************

gen roa = ni/at

***************************************************************
*                      Compensation
**************************************************************

by gvkey year, sort: egen tdc1_firm_mean = mean(tdc1)
gen tdc1_d = tdc1-tdc1_firm_mean
by co_per_rol, sort: egen tdc1_dmean = mean(tdc1_d)
by co_per_rol, sort: egen tdc1_mean = mean(tdc1)

tab nc, sum(tdc1_d)
tab nc, sum(tdc1_dmean)

gen total_alt2_sum = total_alt2-pension_chg-othcomp-noneq_incent
gen current = salary+bonus 
* gen current = salary+bonus+noneq_incent
gen deferred = shrs_vest_val+opt_exer_val

gen current_rate = current/total_alt2_sum
gen deferred_rate = deferred/total_alt2_sum

gen vest_rate = vest/unvest

gen deferred_alt = rstkgrnt+opt_exer_val+ltip
gen current_rate_alt = current/tdc2
gen deferred_rate_alt = deferred_alt/tdc2

replace deferred = deferred_alt if mi(deferred)

***************************************************************
*                      LOGS
***************************************************************

scalar c = 0.01

gen l_emp = log(emp+c)
bysort co_per_rol: gen l_emp_lag = l_emp[_n-1]
gen l_at = log(at+c)
gen l_ppent = log(ppent+c)
gen l_ppegt = log(ppegt+c)


gen l_revt = log(revt+c)
gen l_capx = log(capx+c)
gen l_xrd = log(xrd+c)
gen l_xsga = log(xsga+c)
gen l_gp = log(gp+c)
gen l_oibdp = log(oibdp+c)
gen l_pi = log(pi+c)
gen l_roa = log(1+roa)
gen l_tobinq = log(tobinq+c)
gen l_tobinq_lag = log(tobinq_lag+c)
gen l_cash = log(cash+c)

gen l_term = log(term_pymt+c)
gen l_total_alt1 = log(total_alt1+c)
gen l_total_alt2 = log(total_alt2+c)
gen l_tdc1_dmean = log(tdc1_dmean+c)
gen l_tdc1_mean = log(tdc1_mean+c)
gen l_tdc1 = log(tdc1+c)
gen l_tdc2 = log(tdc2+c)
gen l_current = log(current+c)
gen l_deferred = log(deferred+c)
gen l_vest = log(vest+c)
gen l_unvest = log(unvest+c)
