
i_kappa_star_t0 = find(kappa<=kappa_bar_star_t0,1,'last');
i_kappa_cap = find(kappa<=kappa_bar_cap,1,'last');
i_kappa_bar_star_ss = find(kappa<=kappa_bar_star_ss,1,'last');

%% Equilibrium

disp('   Equilibrium:')
fprintf('       Fraction with noncompete contracts = %.4g\n',frac_n)  
fprintf('       Cost threshold, kappa_bar = %.4g\n',kappa_bar)  
fprintf('       Noncompete duration = %.2g years\n',pie)
fprintf('       Noncompete duration = %.3g months\n',pie*12)
fprintf('       Output = %.3g\n',Y)
fprintf('       Buyout = %.3g\n',theta_bar_n-1)
fprintf('       Rent = %.3g\n',lambda*p*(1-F(theta_bar_n))*(theta_bar_n-1)) 
M_temp = [theta_bar_c theta_bar_n;...
          j2j_c j2j_n;...
          sep_c sep_n;...
          mu_c Emu_n;...
          cmu_c Ecmu_n;...
          zetap_c zetap_n];
disp(array2table(M_temp,...
         'VariableNames',{'Standard','Noncompete'},...
         'RowNames',{'Poaching Threshold','J2J rate','Sep rate','Drift', 'Invest rate', 'Pareto tail'}))
fprintf('       J2J transition rate = %.3g%%\n',j2j*100)
fprintf('       Separation rate = %.3g%%\n',sep*100) 
fprintf('       Investment rate = %.3g%%\n',cmu*100) 
disp(' ')   

%% Social Optimum

disp('   Social Optimum: Time-0 Welfare')
fprintf('       Fraction with noncompete contracts = %.3g\n',frac_n_star_t0)      
fprintf('       Cost threshold, kappa_bar = %.3g\n',kappa_bar_star_t0)  
fprintf('       Noncompete duration cap, according to the analytical formula \n')
fprintf('           for cost type of 0 = %.3g years\n',pie_star_t0(1))   
fprintf('                              = %.3g months\n',pie_star_t0(1)*12)   
fprintf('           for marginal cost type = %.3g years\n',pie_star_t0(i_kappa_star_t0))   
fprintf('                                  = %.3g months\n',pie_star_t0(i_kappa_star_t0)*12)   
fprintf('           Delta* for cost type of 0 = %.3g\n', Delta_star_t0(1))
fprintf('           Delta for cost type of 0 = %.3g\n', Delta(1))
fprintf('           If decreasing monotone hazard rate, upper bond\n')
fprintf('               using Delta* for cost type of 0 = %.3g years\n',log(1+epsilon*Delta_star_t0(1)/(epsilon*Delta_star_t0(1)+1)*(exp(r*pie)-1))/r)   
fprintf('               using Delta for cost type of 0 = %.3g years\n',log(1+epsilon*Delta(1)/(epsilon*Delta(1)+1)*(exp(r*pie)-1))/r)   
fprintf('               using Delta* for cost type of 0, approx = %.3g years\n',epsilon*Delta_star_t0(1)/(epsilon*Delta_star_t0(1)+1)*pie)   
fprintf('           If increasing monotone hazard rate and decreasing density, \n')
fprintf('               using Delta* for cost type of 0 = %.3g years\n',log(1+epsilon*Delta_star_t0(1)/(epsilon*Delta_star_t0(1)+1)*(exp(r*pie)*(1-F(theta_bar_n))/(1-F(1))-1))/r)
fprintf('               using Delta* for cost type of 0, approx = %.3g years\n',epsilon*Delta_star_t0(1)/(epsilon*Delta_star_t0(1)+1)*(pie+(F(theta_bar_n)-F(1))/(1-F(1))))   
fprintf('       J2J transition rate = %.3g%%\n',j2j_star_t0*100)
fprintf('                    change = %.3g%%\n',(j2j_star_t0-j2j)*100)
fprintf('       Separation rate = %.3g%%\n',sep_star_t0*100) 
fprintf('                change = %.3g%%\n',(sep_star_t0-sep)*100)
fprintf('       Investment rate = %.3g%%\n',cmu_star_t0*100) 
fprintf('                change = %.3g%%\n',(cmu_star_t0-cmu)*100)
fprintf('       Welfare gain = %.3g%%\n',dS_t0*100)
fprintf('       Decomposition\n')
fprintf('         Reallocation = %.3g%%\n',dS_reallocate_t0*100)
fprintf('         Investment = %.3g%%\n',dS_invest_t0*100)
fprintf('         Selection = %.3g%%\n',dS_select_t0*100)
fprintf('       Steady-State Welfare = %.3g\n',S_ss_star_t0)
fprintf('       Steady-State Output = %.3g\n',Y_star_t0)
fprintf('       Steady-State Output Gain  = %.3g%%\n',dY_t0*100)    
fprintf('       Decomposition\n')
fprintf('         Reallocation = %.3g%%\n',dY_reallocate_t0*100)
fprintf('         Investment = %.3g%%\n',dY_invest_t0*100)
fprintf('         Selection = %.3g%%\n',dY_select_t0*100)
disp(' ')   

disp('   Duration Cap Only')
fprintf('       Fraction with noncompete = %.3g\n',frac_n_cap)      
fprintf('       Cost threshold, kappa_bar = %.3g\n',kappa_bar_cap)  
fprintf('       Noncompete duration cap, for cost type of 0 = %.3g\n',pie_star_t0(1))   
fprintf('       Noncompete duration cap, for marginal cost type = %.3g\n',pie_star_t0(i_kappa_cap))  
fprintf('       J2J transition rate = %.3g%%\n',j2j_cap*100)
fprintf('                    change = %.3g%%\n',(j2j_cap-j2j)*100)
fprintf('       Separation rate = %.3g%%\n',sep_cap*100) 
fprintf('                change = %.3g%%\n',(sep_cap-sep)*100)
fprintf('       Investment rate = %.3g%%\n',cmu_cap*100) 
fprintf('                change = %.3g%%\n',(cmu_cap-cmu)*100)
fprintf('       Output = %.3g\n',Y_cap)
fprintf('       Welfare gain = %.3g%%\n',dS_cap*100)
fprintf('       Decomposition\n')
fprintf('         Reallocation = %.3g%%\n',dS_reallocate_cap*100)
fprintf('         Investment = %.3g%%\n',dS_invest_cap*100)
fprintf('         Selection = %.3g%%\n',dS_select_cap*100)
fprintf('       Steady-State Welfare = %.3g\n',S_ss_cap)
fprintf('       Steady-State Output = %.3g\n',Y_cap)
fprintf('       Steady-State Output Gain  = %.3g%%\n',dY_cap*100)    
fprintf('       Decomposition\n')
fprintf('         Reallocation = %.3g%%\n',dY_reallocate_cap*100)
fprintf('         Investment = %.3g%%\n',dY_invest_cap*100)
fprintf('         Selection = %.3g%%\n',dY_select_cap*100)    
disp(' ')       

%% Steady State

disp('   Steady-State Welfare')
fprintf('       Fraction with noncompete = %.3g\n',frac_n_star_ss)      
fprintf('       Cost threshold, kappa_bar = %.3g\n',kappa_bar_star_ss)  
fprintf('       Noncompete duration cap, for cost type of 0, years = %.3g\n',pie_star_ss(1))   
fprintf('       Noncompete duration cap, for marginal cost type, years = %.3g\n',pie_star_ss(i_kappa_bar_star_ss))       
fprintf('       J2J transition rate = %.3g%%\n',j2j_star_ss*100)
fprintf('                    change = %.3g%%\n',(j2j_star_ss-j2j)*100)
fprintf('       Separation rate = %.3g%%\n',sep_star_ss*100) 
fprintf('                change = %.3g%%\n',(sep_star_ss-sep)*100)
fprintf('       Investment rate = %.3g%%\n',cmu_star_ss*100) 
fprintf('                change = %.3g%%\n',(cmu_star_ss-cmu)*100)
fprintf('       Output = %.5g\n',Y_star_ss)
fprintf('       Welfare gain = %.3g%%\n',dY_ss*100)
fprintf('       Decomposition\n')
fprintf('         Reallocation = %.3g%%\n',dY_reallocate_ss*100)
fprintf('         Investment = %.3g%%\n',dY_invest_ss*100)
fprintf('         Selection = %.3g%%\n',dY_select_ss*100)
disp(' ')  

%% Additional Results

if i_p==N_p
    
    %% Additional Moments
    
    fprintf('Additional Moments, p = %.3g\n',p_vec(N_p))

    fprintf('   Investment rate = %0.1f%%\n',cmu_c*100)
    fprintf('   Investment cost response, type 0 = %0.1f%%\n',(c(mu_n_vec(N_p,1))-cmu_c_vec(N_p))*100)
    fprintf('    formula appprox elasticity, type 0 = %0.2g\n', dlogcmu_data/cmu_c_data*(r-mu_c_vec(N_p))/(lambda*(theta_bar_n_vec(N_p)-1)*(1-F(theta_bar_n_vec(N_p))))-1)
    fprintf('   Investment cost response, average = %0.1f%%\n',(Ecmu_n_vec(N_p)-c(mu_c_vec(N_p)))*100)
    fprintf('    formula appprox elasticity, average = %0.2g\n', dlogcmu_data/cmu_c_data*(r-mu_c_vec(N_p))/(lambda*(theta_bar_n_vec(N_p)-1)*(1-F(theta_bar_n_vec(N_p)))-kappa_mean/j_c)-1)

    fprintf('   dSep/dp = %.3g\n', (sep_n_vec(N_p)-sep_n_vec(N_p-1))/(p_vec(N_p)-p_vec(N_p-1)))
    fprintf('   dSep/dInv = %.3g\n', (sep_n_vec(N_p)-sep_n_vec(N_p-1))/(Ecmu_n_vec(N_p)-Ecmu_n_vec(N_p-1)))
    fprintf('   Separate rate, w.o. noncompete = %.3g\n',sep_c_vec(N_p))
    fprintf('   Separate rate diff = %.3g\n',sep_n_vec(N_p)-sep_c_vec(N_p))
    fprintf('   Noncompete duration = %.3g\n',pie_vec(N_p))

    fprintf('   Pareto tail = %.3g\n',zetap_c)

    fprintf('   Fraction with noncompete = %.3g\n',frac_n_vec(N_p))
    fprintf('   Variation, d(fraction with noncompete)/dp = %.3g\n',(frac_n_vec(N_p)-frac_n_vec(N_p-1))/(p_vec(N_p)-p_vec(N_p-1)))


    %% Display Wage Moments
    
    % save wage data for log-normal case
    if case_solve_wage==1 && kappa_case==1

        t0 = 0;
        t1 = t(10/dt);
        disp('   Standard Contract')
        fprintf('       Wage growth (tenure) = %.3g\n',(wmean_c_vec{N_p}(1+10/dt)-wmean_c_vec{N_p}(t==t0))/10)

        initial_wage = exp(x0_c_vec(N_p));
        peak_wage  = exp(xu_c_vec(N_p));
        wage_ratio = peak_wage/initial_wage;
        fprintf('       Peak-to-initial wage ratio = %.3g\n',wage_ratio)

        save(fullfile(dir,'output/data','wage_tenure_model.mat'),'t','N_p','xmean_c','xmean_n','wmean_c','wmean_n')

        % Saving Wage Process in txt File
        filename = fullfile(dir,'output/data','wage_tenure_model.txt');
        fileID = fopen(filename,'w');
        fprintf(fileID,'%6s %12s %12s %12s %12s\r\n','t','x_c','x_n','w_c','w_n');
        for i=1:length(t)
             if t(i)>=t0 && t(i)<=t0+10
                fprintf(fileID,'%6.2f %12.8f %12.8f %12.8f %12.8f\n',[t(i)-t0+1;xmean_c_vec{N_p}(i);xmean_n_vec{N_p}{1}(i);wmean_c_vec{N_p}(i);wmean_n_vec{N_p}{1}(i)]);  
            end
        end
        fclose(fileID);

    end

end
