
%% Initialize the setting

clear;
close all;
clc;
format compact
format short

plotfontsize  = 18;
labelfontsize = 18;
linecolor = 1/255*[0 0 153];

%% Folder path 

dir = fileparts(fileparts(cd));
dir_fig = fullfile(dir,'output/figures/baseline');
if ~exist(dir_fig,'dir')
    mkdir(dir_fig)
end
    
%% Load data

load(fullfile(dir,'output/data','variation_p_model.mat'))
data_filename = fullfile(fileparts(dir),'empirical/analysis/input/aggregate_data/nc_state.csv');
T = readtable(data_filename);
TT = table2array(T(:,2:end));
label = table2cell(T(:,1));

%% Plot: cross state variation

figure('pos',[100 100 450 360])
plot(p_vec,frac_n_vec,'Color',[0 0 0],'LineWidth',3)
hold on 
xx = (TT(:,2)+0.65)/(max(TT(:,2))+0.65);
scatter(xx,TT(:,6),TT(:,3),linecolor)
text(xx+0.01,TT(:,6),label,'HorizontalAlignment','left','FontName','Arial', 'Fontsize', 13);
hold off
pbaspect([1.5 1 1])
xlh = xlabel('Enforcement probability','FontName','Arial','FontSize',labelfontsize);
ylh = ylabel('Noncompete prevalence','FontName','Arial','FontSize',labelfontsize);
xlim([0 1])
ylim([0 1])
xticks([0 .2 .4 .6 .8 1])
yticks([0 .2 .4 .6 .8 1])
legend({'Model','Data'},'Box','off','Location','northwest','FontSize',labelfontsize);
set(gca,'FontName','Arial','FontSize',plotfontsize,'LineWidth',0.5,'FontSmoothing','on','XColor','k','YColor','k')
    
filename = fullfile(dir_fig,'data_moment_prevalence.eps');
print(filename, '-depsc')


