titlefontsize = 12;
labelfontsize = 12;
plotfontsize  = 12;
linewidth = 4;
linewidth_bg = 1;
markersize =1;

%% Plot Solutions

min_x_temp = exp(min([x_c_vec{i_p,1};cell2mat(x_n_vec{i_p})]));
max_x_temp = exp(max([x_c_vec{i_p,1};cell2mat(x_n_vec{i_p})]));
min_u_temp = min([u_c_vec{i_p};cell2mat(u_n_vec{i_p})]);
max_u_temp = max([u_c_vec{i_p};cell2mat(u_n_vec{i_p})]);
i_kappa_bar = i_kappa_bar_vec(i_p);

figure('pos',[100 100 1800 1000])
set(gca,'FontSize',plotfontsize)

subplot(3,3,1)
plot(exp(x_c_vec{i_p}),u_c_vec{i_p},'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),u_n_vec{i_p}{1},'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),u_n_vec{i_p}{i_kappa_bar},'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),u_n_vec{i_p}{i_kappa},'y.','markersize',markersize)
end
plot(exp(xl_c_vec(i_p))*ones(1,2),[min_u_temp max_u_temp],'b:','LineWidth',linewidth_bg)
plot(exp(xu_c_vec(i_p))*ones(1,2),[min_u_temp max_u_temp],'b:','LineWidth',linewidth_bg)
plot(exp(x0_c_vec(i_p))*ones(1,2),[min_u_temp max_u_temp],'b:','LineWidth',linewidth_bg)
plot(exp(xl_n_vec(i_p,1))*ones(1,2),[min_u_temp max_u_temp],'r:','LineWidth',linewidth_bg)
plot(exp(xu_n_vec(i_p,1))*ones(1,2),[min_u_temp max_u_temp],'r:','LineWidth',linewidth_bg)
plot(exp(x0_n_vec(i_p,1))*ones(1,2),[min_u_temp max_u_temp],'r:','LineWidth',linewidth_bg)
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Promised Utility, $u(x)$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])
ylim([min_u_temp max_u_temp])

subplot(3,3,2)
plot(exp(x_c_vec{i_p}),u_c_vec{i_p}/j_c_vec(i_p),'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),u_n_vec{i_p}{1}/j_n_vec(i_p,1),'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),u_n_vec{i_p}{i_kappa_bar}/j_n_vec(i_p,i_kappa_bar),'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),u_n_vec{i_p}{i_kappa}/j_n_vec(i_p,i_kappa),'y.','markersize',markersize)
end
plot(exp(xl_c_vec(i_p))*ones(1,2),[0 1],'b:','LineWidth',linewidth_bg)
plot(exp(xu_c_vec(i_p))*ones(1,2),[0 1],'b:','LineWidth',linewidth_bg)
plot(exp(x0_c_vec(i_p))*ones(1,2),[0 1],'b:','LineWidth',linewidth_bg)
plot(exp(xl_n_vec(i_p,1))*ones(1,2),[0 1],'r:','LineWidth',linewidth_bg)
plot(exp(xu_n_vec(i_p,1))*ones(1,2),[0 1],'r:','LineWidth',linewidth_bg)
plot(exp(x0_n_vec(i_p,1))*ones(1,2),[0 1],'r:','LineWidth',linewidth_bg)
plot([min_x_temp; max_x_temp],betal*ones(2,1),'k-.')
plot([min_x_temp; max_x_temp],betau*ones(2,1),'k-.')
plot([min_x_temp; max_x_temp],beta*ones(2,1),'k-.')
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Promised Utility, $u(x)/j$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])
ylim([0 1.1])

subplot(3,3,3)
plot(exp(x_c_vec{i_p}),du_c_vec{i_p},'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),du_n_vec{i_p}{1},'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),du_n_vec{i_p}{i_kappa_bar},'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),du_n_vec{i_p}{i_kappa},'y.','markersize',markersize)
end
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Smooth Pasting: Utility, $du(x)/dx$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])

subplot(3,3,4)
plot(exp(x_c_vec{i_p}),ddu_c_vec{i_p},'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),ddu_n_vec{i_p}{1},'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),ddu_n_vec{i_p}{i_kappa_bar},'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),ddu_n_vec{i_p}{i_kappa},'y.','markersize',markersize)
end
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('$d^2u(x)/dx^2$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])

subplot(3,3,5)
plot(exp(x_c_vec{i_p,1}),check_HJB_c_vec{i_p},'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),check_HJB_n_vec{i_p}{1},'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),check_HJB_n_vec{i_p}{i_kappa_bar},'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),check_HJB_n_vec{i_p}{i_kappa},'y.','markersize',markersize)
end
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Prdouct Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Check HJB','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])

subplot(3,3,6)
plot(exp(x_c_vec{i_p}),theta_l_c_vec{i_p},'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),theta_l_n_vec{i_p}{1},'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),theta_l_n_vec{i_p}{i_kappa_bar},'k-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{1}),theta_l_u_vec{i_p}{1},'r:','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),theta_l_u_vec{i_p}{i_kappa_bar},'k:','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),theta_l_n_vec{i_p}{i_kappa},'y.','markersize',markersize)
    plot(exp(x_n_vec{i_p}{i_kappa}),theta_bar_n_vec(i_p)*ones(size(x_n_vec{i_p}{i_kappa})),'y:','markersize',markersize)
end
plot(exp(x_c_vec{i_p}),theta_bar_c_vec(i_p)*ones(size(x_c_vec{i_p})),'b:','LineWidth',linewidth_bg)
plot(exp(x_n_vec{i_p}{1}),theta_bar_n_vec(i_p)*ones(size(x_n_vec{i_p}{1})),'r:','LineWidth',linewidth_bg)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),theta_bar_n_vec(i_p)*ones(size(x_n_vec{i_p}{i_kappa_bar})),'k:','LineWidth',linewidth_bg)
plot(exp(xl_c_vec(i_p))*ones(1,2),[theta_min theta_bar_n_vec(i_p)],'b:','LineWidth',linewidth_bg)
plot(exp(xu_c_vec(i_p))*ones(1,2),[theta_min theta_bar_n_vec(i_p)],'b:','LineWidth',linewidth_bg)
plot(exp(x0_c_vec(i_p))*ones(1,2),[theta_min theta_bar_n_vec(i_p)],'b:','LineWidth',linewidth_bg)
plot(exp(xl_n_vec(i_p,1))*ones(1,2),[theta_min theta_bar_n_vec(i_p)],'r:','LineWidth',linewidth_bg)
plot(exp(xu_n_vec(i_p,1))*ones(1,2),[theta_min theta_bar_n_vec(i_p)],'r:','LineWidth',linewidth_bg)
plot(exp(x0_n_vec(i_p,1))*ones(1,2),[theta_min theta_bar_n_vec(i_p)],'r:','LineWidth',linewidth_bg)
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$):enforce","Noncompete (marginal):enforce","Noncompete ($\kappa=0$):unenforce","Noncompete (marginal):unenforce",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Bid Up Lower Bound, $\underline{\theta}(x)$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])

subplot(3,3,7)
plot(exp(x_c_vec{i_p}),F(theta_bar_c_vec(i_p))-F(theta_l_c_vec{i_p}),'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),F(theta_bar_n_vec(i_p))-F(theta_l_n_vec{i_p}{1}),'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),F(theta_bar_n_vec(i_p))-F(theta_l_n_vec{i_p}{i_kappa_bar}),'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),F(theta_bar_n_vec(i_p))-F(theta_l_n_vec{i_p}{i_kappa}),'y.','markersize',markersize)
end
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('$F(\bar{\theta})-F(\underline{\theta}(x))$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])

subplot(3,3,8)
plot(exp(x_c_vec{i_p}),Istar_c_vec{i_p},'b-','LineWidth',linewidth)
hold on
plot(exp(x_n_vec{i_p}{1}),Istar_n_vec{i_p}{1},'r-.','LineWidth',linewidth)
plot(exp(x_n_vec{i_p}{i_kappa_bar}),Istar_n_vec{i_p}{i_kappa_bar},'k-.','LineWidth',linewidth)
for i_kappa=1:N_kappa
    plot(exp(x_n_vec{i_p}{i_kappa}),Istar_n_vec{i_p}{i_kappa},'y.','markersize',markersize)
end
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)","Noncompete (marginal)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Wage/Product Ratio, $\exp(x)$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Bid Up Lower Bound, $I(x)$','FontSize',labelfontsize,'interpreter','latex')
xlim([min_x_temp max_x_temp])
ylim([0 max([Istar_c_vec{i_p};Istar_n_vec{i_p}{1}])])

subplot(3,3,9)
z = linspace(0,10,100)';
plot(z,gz_prox_c_vec{i_p}(z),'b-','LineWidth',linewidth)
hold on
plot(z,gz_prox_n_vec{i_p}(z),'r-.')
hold off
pbaspect([1.5 1 1])
legend("No Noncompete","Noncompete ($\kappa=0$)",'Location','SouthEast','interpreter','latex')
legend('boxoff')
xlabel('Productivity, $z$','FontSize',labelfontsize,'interpreter','latex')
ylabel('Density, $g(z)$','FontSize',labelfontsize,'interpreter','latex')
xlim([min(z) max(z)])

filename = fullfile(dir_fig,'solution_wage.eps');
print(filename, '-depsc')

