
%% kappa_bar, according to private agents

% marginal type
kappa_bar_cap = min(max(interp1(j_n_star_t0,kappa,j_c,'linear','extrap'),0),kappau);
frac_n_cap = cdf(pd,kappa_bar_cap);

% endogenous grid
kappa_cap  = sort([kappa_eqm kappa_bar_cap]);
i_n_cap    = (kappa_cap<=kappa_bar_cap);  
frac_n_cap_approx = trapz(kappa_cap,i_n_cap.*pdf(pd,kappa_cap));
if frac_n_cap_approx>0
    fkappa_cap = pdf(pd,kappa_cap)/frac_n_cap_approx;
else
    fkappa_cap = zeros(size(kappa_cap));
end
if frac_n_approx>0
   fkappa_cap_eqm = pdf(pd,kappa_cap)/frac_n_approx;
else
   fkappa_cap_eqm = zeros(size(kappa_cap));
end

%% J2J and Separation Rates, Investments

j2j_cap = trapz(kappa_cap,interp1(kappa,j2j_n_star_t0,kappa_cap).*i_n_cap.*fkappa_cap)*frac_n_cap+j2j_c*(1-frac_n_cap);
sep_cap = j2j_cap+delta;
cmu_cap = trapz(kappa_cap,interp1(kappa,c(mu_n_star_t0),kappa_cap).*i_n_cap.*fkappa_cap)*frac_n_cap+cmu_c*(1-frac_n_cap);

%% Welfare

% new born 
S_1_cap   = (rho+delta)/rho*(trapz(kappa_cap,interp1(kappa,s_n_star_t0,kappa_cap).*i_n_cap.*fkappa_cap)*frac_n_cap+s_c*(1-frac_n_cap));
% time 0
s_cap     = s_c.*(1-i_n_cap)+interp1(kappa,s_n_star_t0,kappa_cap).*i_n_cap;
S_cap     = trapz(kappa_cap,s_cap.*interp1(kappa,Z_n,kappa_cap).*fkappa_cap_eqm)*frac_n+s_c*Z_c*(1-frac_n)+delta/(rho+delta)*S_1_cap;    
% steady state
S_ss_cap  = trapz(kappa_cap,interp1(kappa,s_n_star_t0.*Z_n_star_t0,kappa_cap).*i_n_cap.*fkappa_cap)*frac_n_cap+s_c*Z_c*(1-frac_n_cap)+delta/(rho+delta)*S_1_cap;

%% Welfare T0 decomposition

dS_cap = S_cap/S_ss-1;
dS_reallocate_cap = dS_reallocate_t0;
dS_invest_cap = dS_invest_t0;
dS_select_cap = (S_cap-S_invest_t0)/S_ss;

%% Steady-state output    

% Productivity (overall output): interpretation of contracting cost as disutility
Z_cap = trapz(kappa_cap,interp1(kappa,Z_n_star_t0,kappa_cap).*i_n_cap.*fkappa_cap)*frac_n_cap+Z_c*(1-frac_n_cap);
Y_cap = trapz(kappa_cap,interp1(kappa,Y_n_star_t0,kappa_cap).*i_n_cap.*fkappa_cap)*frac_n_cap+Y_c*(1-frac_n_cap);
    
%% Decomposition

dY_cap = Y_cap/Y-1;
dY_reallocate_cap = dY_reallocate_t0;
dY_invest_cap = dY_invest_t0;
dY_select_cap = (Y_cap-Y_invest_t0)/Y;



