
%% optimal duration

% let mu_n be optimal in Delta    
j_n_star_ss  = zeros(1,N_kappa);
mu_n_star_ss = zeros(1,N_kappa);
theta_bar_n_star_ss = zeros(1,N_kappa);
for i_kappa = 1:N_kappa 
    if case_duration_cap==0    
        eq_nstar_ss = @(x) [(r-x(1)-lambda*p*(1-F(x(3)))*(x(3)-1))*x(2)-(1-c(x(1))-kappa(i_kappa));...
                               cp(x(1))-x(2);...
                               epsilon/(epsilon+(r-x(1)-lambda*p*(1-F(x(3)))*(x(3)-1))^2/(rho+lambda*(p*EE(x(3))+(1-p)*EE(1)))/(x(1)-1/2*sigma^2))*(1-F(x(3)))/f(x(3))+1-x(3)];
                           % in comparison to the code in solve_social_optimum_welfare_t0: differ by rho
    elseif case_duration_cap==1
        eq_nstar_ss = @(x) [(r-x(1)-lambda*p*(1-F(x(3)))*(x(3)-1))*x(2)-(1-c(x(1))-kappa(i_kappa));...
                               cp(x(1))-x(2);...
                               x(3)-exp(r*dur_cap)];
    end
    if i_kappa==1
        temp_guess = [mu_n(1);j_n(1);theta_bar_n];
    else
        temp_guess = temp;
    end  
    temp    = fsolve(eq_nstar_ss, temp_guess, options_fsolve);
    mu_n_star_ss(i_kappa)  = temp(1);
    j_n_star_ss(i_kappa)   = temp(2);   
    theta_bar_n_star_ss(i_kappa) = temp(3);
end
pie_star_ss = 1/r*log(theta_bar_n_star_ss);

% 
Delta1_star_ss = (rho+lambda*(p*EE(theta_bar_n_star_ss)+(1-p)*EE(1)))./(r-mu_n_star_ss-lambda*p*ER(theta_bar_n_star_ss));
Delta2_star_ss = (mu_n_star_ss-1/2*sigma^2)./(r-mu_n_star_ss-lambda*p*ER(theta_bar_n_star_ss));
Delta_star_ss  = Delta1_star_ss.*Delta2_star_ss;

%% kappa_bar

D_n_star_ss = delta-mu_n_star_ss-lambda*(p*ES(theta_bar_n_star_ss)+(1-p)*ES(theta_bar_c));
Z_n_star_ss = delta./D_n_star_ss;
Y_n_star_ss = delta*(1-c(mu_n_star_ss)-kappa)./D_n_star_ss;

% marginal type
kappa_bar_star_ss = min(max(interp1(Y_n_star_ss,kappa,Y_c,'linear','extrap'),0),kappau);
frac_n_star_ss = cdf(pd,kappa_bar_star_ss);

% endogeous grid
kappa_star_ss  = sort([kappa_eqm kappa_bar_star_ss]);
i_n_star_ss    = (kappa_star_ss<=kappa_bar_star_ss);    
frac_n_star_ss_approx = trapz(kappa_star_ss,i_n_star_ss.*pdf(pd,kappa_star_ss));
if frac_n_star_ss_approx>0
    fkappa_star_ss = pdf(pd,kappa_star_ss)/frac_n_star_ss_approx;
else
    fkappa_star_ss = zeros(size(kappa_star_ss));
end

%% J2J rates, separation rates, investment rates

j2j_n_star_ss = lambda*(p*(1-F(theta_bar_n_star_ss))+(1-p)*(1-F(theta_bar_c)));
sep_n_star_ss = j2j_n_star_ss+delta;

j2j_star_ss = trapz(kappa_star_ss,interp1(kappa,j2j_n_star_ss,kappa_star_ss).*i_n_star_ss.*fkappa_star_ss)*frac_n_star_ss+j2j_c*(1-frac_n_star_ss);
sep_star_ss = j2j_star_ss+delta;
cmu_star_ss = trapz(kappa_star_ss,interp1(kappa,c(mu_n_star_ss),kappa_star_ss).*i_n_star_ss.*fkappa_star_ss)*frac_n_star_ss+cmu_c*(1-frac_n_star_ss);

%% Steady-state output    

% Productivity 
Z_star_ss = trapz(kappa_star_ss,interp1(kappa,Z_n_star_ss,kappa_star_ss).*i_n_star_ss.*fkappa_star_ss)*frac_n_star_ss+Z_c*(1-frac_n_star_ss);
% Consumption (net output)
Y_star_ss = trapz(kappa_star_ss,interp1(kappa,Y_n_star_ss,kappa_star_ss).*i_n_star_ss.*fkappa_star_ss)*frac_n_star_ss+Y_c*(1-frac_n_star_ss);

%% Steady-state welfare 

s_n_star_ss = (1-c(mu_n_star_ss)-kappa)./(r-mu_n_star_ss-lambda*(p*ES(theta_bar_n_star_ss)+(1-p)*ES(theta_bar_c)));
Z_n_star_ss   = delta./D_n_star_ss;

% time 0
S_1_star_ss   = (rho+delta)/rho*(trapz(kappa_star_ss,interp1(kappa,s_n_star_ss,kappa_star_ss).*i_n_star_ss.*fkappa_star_ss)*frac_n_star_ss+s_c*(1-frac_n_star_ss));
S_ss_star_ss  = trapz(kappa_star_ss,interp1(kappa,s_n_star_ss.*Z_n_star_ss,kappa_star_ss).*i_n_star_ss.*fkappa_star_ss)*frac_n_star_ss+s_c*Z_c*(1-frac_n_star_ss)+delta/(rho+delta)*S_1_star_ss;

%% Decomposition

dY_ss = Y_star_ss/Y-1;

D_n_reallocate_ss = delta-mu_n-lambda*(p*ES(theta_bar_n_star_ss)+(1-p)*ES(theta_bar_c));
Y_n_reallocate_ss = delta*(1-c(mu_n)-kappa)./D_n_reallocate_ss;
Y_reallocate_ss = trapz(kappa_eqm,interp1(kappa,Y_n_reallocate_ss,kappa_eqm).*fkappa_eqm)*frac_n+Y_c*(1-frac_n);
dY_reallocate_ss = (Y_reallocate_ss-Y)/Y;

Y_invest_ss = trapz(kappa_eqm,interp1(kappa,Y_n_star_ss,kappa_eqm).*fkappa_eqm)*frac_n+Y_c*(1-frac_n);
dY_invest_ss = (Y_invest_ss-Y_reallocate_ss)/Y;

dY_select_ss = (Y_star_ss-Y_invest_ss)/Y;
