
%% optimal duration

j_n_star_t0  = zeros(1,N_kappa);
mu_n_star_t0 = zeros(1,N_kappa);
theta_bar_n_star_t0 = zeros(1,N_kappa);
for i_kappa = 1:N_kappa
    if case_duration_cap==0
        eq_nstar_t0 = @(x) [(r-x(1)-lambda*p*ER(x(3)))*x(2)-(1-c(x(1))-kappa(i_kappa));...
                               cp(x(1))-x(2);...
                               epsilon/(epsilon+(r-x(1)-lambda*p*ER(x(3)))^2/(lambda*(p*EE(x(3))+(1-p)*EE(1)))/(x(1)-1/2*sigma^2))*(1-F(x(3)))/f(x(3))+1-x(3)];
    elseif case_duration_cap==1
        eq_nstar_t0 = @(x) [(r-x(1)-lambda*p*ER(x(3)))*x(2)-(1-c(x(1))-kappa(i_kappa));...
                               cp(x(1))-x(2);...
                               x(3)-exp(r*dur_cap)];
    end
    temp_guess = [mu_c;j_c;1];
    temp    = fsolve(eq_nstar_t0, temp_guess, options_fsolve);
    mu_n_star_t0(i_kappa)  = temp(1);
    j_n_star_t0(i_kappa)   = temp(2);   
    theta_bar_n_star_t0(i_kappa) = temp(3);
end
pie_star_t0 = 1/r*log(theta_bar_n_star_t0);

Delta1_star_t0 = (lambda*(p*EE(theta_bar_n_star_t0)+(1-p)*EE(1)))./(r-mu_n_star_t0-lambda*p*ER(theta_bar_n_star_t0));
Delta2_star_t0 = (mu_n_star_t0-1/2*sigma^2)./(r-mu_n_star_t0-lambda*p*ER(theta_bar_n_star_t0));
Delta_star_t0  = Delta1_star_t0.*Delta2_star_t0;

%% kappa_bar

D_n_star_t0 = delta-mu_n_star_t0-lambda*(p*ES(theta_bar_n_star_t0)+(1-p)*ES(theta_bar_c));
Z_n_star_t0 = delta./D_n_star_t0;
Y_n_star_t0 = delta*(1-c(mu_n_star_t0)-kappa)./D_n_star_t0;
s_n_star_t0 = (1-c(mu_n_star_t0)-kappa)./(r-mu_n_star_t0-lambda*(p*ES(theta_bar_n_star_t0)+(1-p)*ES(theta_bar_c)));

% marginal type
kappa_bar_star_t0 = min(max(interp1(s_n_star_t0,kappa,s_c,'linear','extrap'),0),kappau);
frac_n_star_t0 = cdf(pd,kappa_bar_star_t0);

% endogeous grid
kappa_star_t0  = sort([kappa_eqm kappa_bar_star_t0]);
i_n_star_t0    = (kappa_star_t0<=kappa_bar_star_t0);    
frac_n_star_t0_approx = trapz(kappa_star_t0,i_n_star_t0.*pdf(pd,kappa_star_t0));
if frac_n_star_t0_approx>0
    fkappa_star_t0 = pdf(pd,kappa_star_t0)/frac_n_star_t0_approx;
else
    fkappa_star_t0 = zeros(size(kappa_star_t0));
end
if frac_n_approx>0
   fkappa_star_t0_eqm = pdf(pd,kappa_star_t0)/frac_n_approx;
else
   fkappa_star_t0_eqm = zeros(size(kappa_star_t0));
end
    
%% J2J rates, separation rates, investment rates

j2j_n_star_t0 = lambda*(p*(1-F(theta_bar_n_star_t0))+(1-p)*(1-F(theta_bar_c)));
sep_n_star_t0 = j2j_n_star_t0+delta;

j2j_star_t0 = trapz(kappa_star_t0,interp1(kappa,j2j_n_star_t0,kappa_star_t0).*i_n_star_t0.*fkappa_star_t0)*frac_n_star_t0+j2j_c*(1-frac_n_star_t0);
sep_star_t0 = j2j_star_t0+delta;
cmu_star_t0 = trapz(kappa_star_t0,interp1(kappa,c(mu_n_star_t0),kappa_star_t0).*i_n_star_t0.*fkappa_star_t0)*frac_n_star_t0+cmu_c*(1-frac_n_star_t0);
  
%% Welfare

% new born
S_1_star_t0   = (rho+delta)/rho*(trapz(kappa_star_t0,interp1(kappa,s_n_star_t0,kappa_star_t0).*i_n_star_t0.*fkappa_star_t0)*frac_n_star_t0+s_c*(1-frac_n_star_t0));
% time 0
s_star_t0     = s_c.*(1-i_n_star_t0)+interp1(kappa,s_n_star_t0,kappa_star_t0).*i_n_star_t0;
S_star_t0     = trapz(kappa_star_t0,s_star_t0.*interp1(kappa,Z_n,kappa_star_t0).*fkappa_star_t0_eqm)*frac_n+s_c*Z_c*(1-frac_n)+delta/(rho+delta)*S_1_star_t0;
% steady state
S_ss_star_t0  = trapz(kappa_star_t0,interp1(kappa,s_n_star_t0.*Z_n_star_t0,kappa_star_t0).*i_n_star_t0.*fkappa_star_t0)*frac_n_star_t0+s_c*Z_c*(1-frac_n_star_t0)+delta/(rho+delta)*S_1_star_t0;

%% Welfare t0 decomposition

dS_t0 = S_star_t0/S_ss-1;

D_n_reallocate_t0 = delta-mu_n-lambda*(p*ES(theta_bar_n_star_t0)+(1-p)*ES(theta_bar_c));
s_n_reallocate_t0 = (1-c(mu_n)-kappa)./(rho+D_n_reallocate_t0);

S_1_reallocate_t0 = (rho+delta)/rho*(trapz(kappa_eqm,interp1(kappa,s_n_reallocate_t0,kappa_eqm).*fkappa_eqm)*frac_n+s_c*(1-frac_n));
S_reallocate_t0 = trapz(kappa_eqm,interp1(kappa,s_n_reallocate_t0.*Z_n,kappa_eqm).*fkappa_eqm)*frac_n+s_c*Z_c*(1-frac_n)+delta/(rho+delta)*S_1_reallocate_t0;  

dS_reallocate_t0 = (S_reallocate_t0-S_ss)/S_ss;

S_1_invest_t0 = (rho+delta)/rho*(trapz(kappa_eqm,interp1(kappa,s_n_star_t0,kappa_eqm).*fkappa_eqm)*frac_n+s_c*(1-frac_n));    
S_invest_t0 = trapz(kappa_eqm,interp1(kappa,s_n_star_t0.*Z_n,kappa_eqm).*fkappa_eqm)*frac_n+s_c*Z_c*(1-frac_n)+delta/(rho+delta)*S_1_invest_t0; 
dS_invest_t0 = (S_invest_t0-S_reallocate_t0)/S_ss;

dS_select_t0 = (S_star_t0-S_invest_t0)/S_ss;

%% Steady-state   

% Productivity
Z_star_t0 = trapz(kappa_star_t0,interp1(kappa,Z_n_star_t0,kappa_star_t0).*i_n_star_t0.*fkappa_star_t0)*frac_n_star_t0+Z_c*(1-frac_n_star_t0);
% Consumption (net output)
Y_star_t0 = trapz(kappa_star_t0,interp1(kappa,Y_n_star_t0,kappa_star_t0).*i_n_star_t0.*fkappa_star_t0)*frac_n_star_t0+Y_c*(1-frac_n_star_t0);

%% Steady-state decomposition

dY_t0 = Y_star_t0/Y-1;

Y_n_reallocate_t0 = delta*(1-c(mu_n)-kappa)./D_n_reallocate_t0;
Y_reallocate_t0 = trapz(kappa_eqm,interp1(kappa,Y_n_reallocate_t0,kappa_eqm).*fkappa_eqm)*frac_n+Y_c*(1-frac_n);
dY_reallocate_t0 = (Y_reallocate_t0-Y)/Y;

Y_invest_t0 = trapz(kappa_eqm,interp1(kappa,Y_n_star_t0,kappa_eqm).*fkappa_eqm)*frac_n+Y_c*(1-frac_n);
dY_invest_t0 = (Y_invest_t0-Y_reallocate_t0)/Y;

dY_select_t0 = (Y_star_t0-Y_invest_t0)/Y;



