%% Prepare

Nx_temp      = length(x_temp);
dx_temp      = zeros(Nx_temp,1);
dx_temp(1:Nx_temp-1) = x_temp(2:Nx_temp)-x_temp(1:Nx_temp-1);
dx_temp(Nx_temp) = dx(Nx_temp-1);
dx2_temp     = dx_temp.^2;

%% Construct matrix

if i==1
    ftemp = [F(theta_l(2:Nx_temp));F(theta_bar)]-F(theta_l);  
    A = lambda*tril(ftemp*ones(1,Nx_temp))/F(theta_bar);
    B = -lambda*diag(F(theta_bar)-F(theta_l))/F(theta_bar);
elseif i==2
    ftemp1 = [F(theta_l(2:Nx_temp));F(theta_bar)]-F(theta_l);          
    A1 = lambda*tril(ftemp1*ones(1,Nx_temp))/F(theta_bar);
    B1 = -lambda*diag(F(theta_bar)-F(theta_l))/F(theta_bar);   
    ftemp2 = [F(theta_l_temp(2:Nx_temp));F(theta_bar_c)]-F(theta_l_temp);                  
    A2 = lambda*tril(ftemp2*ones(1,Nx_temp))/F(theta_bar_c);
    B2 = -lambda*diag(F(theta_bar_c)-F(theta_l_temp))/F(theta_bar_c);   
    A  = p*A1+(1-p)*A2;
    B  = p*B1+(1-p)*B2;
end
A = sparse(A);
B = sparse(B);

Xx     = 1/2*sigma^2./dx2_temp;
Yx     = (-(mu+1/2*sigma^2)./dx_temp-sigma^2./dx2_temp);
Zx     = ((mu+1/2*sigma^2)./dx_temp+1/2*sigma^2./dx2_temp);

lowdiag = Xx(2:Nx_temp);
centdiag = Yx;
centdiag(1) = centdiag(1)+Xx(1);
centdiag(Nx_temp) = centdiag(Nx_temp)+Zx(Nx_temp);
updiag = [0;Zx(1:Nx_temp-1)];

C      = spdiags(centdiag,0,Nx_temp,Nx_temp)+spdiags(lowdiag,-1,Nx_temp,Nx_temp)+spdiags(updiag,1,Nx_temp,Nx_temp);
L      = A+B+C;

%% Stationary distribution 

b = zeros(Nx_temp,1);
i_fix = floor(Nx_temp/1);               
b(i_fix) = 1;
row = [zeros(1,i_fix-1), 1, zeros(1,Nx_temp-i_fix)];
L1 = L;
L1(i_fix,:) = row;

gxstat_temp = L1\b;
gxstat = gxstat_temp/sum(gxstat_temp.*dx_temp);
Gxstat = cumsum(gxstat.*dx_temp);

%% Evolution over time

gx0 = 1./dx_temp.*(x_temp==x0);
gx = sparse(zeros(Nx_temp,Nt+1));
gx(:,1) = gx0;

for i_t = 1:Nt
    gx_old = gx(:,i_t);
    gx_new = (speye(Nx_temp)-L*dt)\gx_old; % implicit method
    gx(:,i_t+1) = gx_new;
    % display
    if mod(i_t,100)==0
        disp(['        Time Iteration = ' num2str(i_t)])
    end
end

Gx = cumsum(gx.*dx_temp);
if i==1
    dxdt = (F(theta_bar)-F(theta_l))/F(theta_bar).*Gx;
elseif i==2
    dxdt = (p*(F(theta_bar)-F(theta_l))/F(theta_bar)+(1-p)*(F(theta_bar_c)-F(theta_l_temp))/F(theta_bar_c)).*Gx;        
end    
xmean  = full(sum(x_temp.*gx.*dx_temp)');
wmean  = xmean+(mu-1/2*sigma^2)*t;
